package xyz.brassgoggledcoders.moarcarts.entities;

import xyz.brassgoggledcoders.moarcarts.renderers.IRenderBlock;
import mods.railcraft.api.carts.IItemCart;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.Optional;

/**
 * @author SkySom
 * TODO: Railcraft - IItemcart
 */
@Optional.Interface(iface = "mods.railcraft.api.carts.IItemCart", modid = "RailcraftAPI|carts")
public abstract class EntityMinecartInventoryTEBase extends EntityMinecartTEBase implements IRenderBlock, IInventory,
		IItemCart
{
	private boolean dropContentsWhenDead = true;

	public EntityMinecartInventoryTEBase(World world, int metadata)
	{
		super(world, metadata);
	}

	public IInventory getIInventoryTileEntity()
	{
		if(this.getTileEntity() instanceof IInventory)
		{
			return (IInventory)this.getTileEntity();
		}
		return null;
	}

	@Override
	public void func_70106_y()
	{
		if (this.dropContentsWhenDead() && !this.shouldSaveDataToItem())
		{
			for (int i = 0; i < this.func_70302_i_(); ++i)
			{
				ItemStack itemstack = this.func_70301_a(i);

				if (itemstack != null)
				{
					float f = this.field_70146_Z.nextFloat() * 0.8F + 0.1F;
					float f1 = this.field_70146_Z.nextFloat() * 0.8F + 0.1F;
					float f2 = this.field_70146_Z.nextFloat() * 0.8F + 0.1F;

					while (itemstack.field_77994_a > 0)
					{
						int j = this.field_70146_Z.nextInt(21) + 10;

						if (j > itemstack.field_77994_a)
						{
							j = itemstack.field_77994_a;
						}

						itemstack.field_77994_a -= j;
						EntityItem entityitem = new EntityItem(this.field_70170_p, this.field_70165_t + (double)f, this.field_70163_u + (double)f1, this.field_70161_v + (double)f2, new ItemStack(itemstack.func_77973_b(), j, itemstack.func_77952_i()));

						if (itemstack.func_77942_o())
						{
							entityitem.func_92059_d().func_77982_d((NBTTagCompound)itemstack.func_77978_p().func_74737_b());
						}

						float f3 = 0.05F;
						entityitem.field_70159_w = (double)((float)this.field_70146_Z.nextGaussian() * f3);
						entityitem.field_70181_x = (double)((float)this.field_70146_Z.nextGaussian() * f3 + 0.2F);
						entityitem.field_70179_y = (double)((float)this.field_70146_Z.nextGaussian() * f3);
						if(!field_70170_p.field_72995_K)
						{
							this.field_70170_p.func_72838_d(entityitem);
						}
					}
				}
			}
		}

		super.func_70106_y();
	}

	@Override
	public void func_71027_c(int dimension)
	{
		this.setDropContentsWhenDead(false);
		super.func_71027_c(dimension);
	}

	@Override
	public boolean func_70300_a(EntityPlayer entityPlayer)
	{
		return entityPlayer.func_70011_f(this.field_70165_t, this.field_70163_u, this.field_70161_v) <= 64D;
	}

	@Override
	public void func_174889_b(EntityPlayer player)
	{

	}

	@Override
	public void func_174886_c(EntityPlayer player)
	{

	}

	@Override
	public int func_70297_j_()
	{
		return this.getIInventoryTileEntity().func_70297_j_();
	}

	@Override
	public boolean func_94041_b(int slotIndex, ItemStack itemStack)
	{
		return this.getIInventoryTileEntity().func_94041_b(slotIndex, itemStack);
	}

	@Override
	public int func_174887_a_(int id)
	{
		return this.getIInventoryTileEntity().func_174887_a_(id);
	}

	@Override
	public void func_174885_b(int id, int value)
	{
		this.getIInventoryTileEntity().func_174885_b(id, value);
	}

	@Override
	public int func_174890_g()
	{
		return this.getIInventoryTileEntity().func_174890_g();
	}

	@Override
	public void func_174888_l()
	{
		this.getIInventoryTileEntity().func_174888_l();
	}

	@Override
	public int func_70302_i_()
	{
		return this.getIInventoryTileEntity().func_70302_i_();
	}

	@Override
	public ItemStack func_70301_a(int slotIndex)
	{
		return this.getIInventoryTileEntity().func_70301_a(slotIndex);
	}

	@Override
	public ItemStack func_70298_a(int slotIndex, int decreaseAmount)
	{
		return this.getIInventoryTileEntity().func_70298_a(slotIndex, decreaseAmount);
	}

	@Override
	public ItemStack func_70304_b(int index)
	{
		return this.getIInventoryTileEntity().func_70304_b(index);
	}

	@Override
	public void func_70299_a(int slotIndex, ItemStack itemStack)
	{
		this.getIInventoryTileEntity().func_70299_a(slotIndex, itemStack);
	}

	@Override
	public boolean canPassItemRequests()
	{
		return true;
	}

	@Override
	public boolean canAcceptPushedItem(EntityMinecart entityMinecart, ItemStack itemStack)
	{
		return true;
	}

	@Override
	public boolean canProvidePulledItem(EntityMinecart entityMinecart, ItemStack itemStack)
	{
		return true;
	}

	public boolean dropContentsWhenDead()
	{
		return dropContentsWhenDead;
	}

	public void setDropContentsWhenDead(boolean drop)
	{
		this.dropContentsWhenDead = drop;
	}

	@Override
	public int getComparatorInputOverride()
	{
		if(!this.getCartBlock().func_149740_M())
		{
			return Container.func_94526_b(this);
		}
		return super.getComparatorInputOverride();
	}
}
